package aexp.hostapp;

import android.app.Service;
import android.os.IBinder;
import android.util.Log;
import android.os.Bundle;
import android.os.DeadObjectException;

public class HostappServiceImpl extends Service {
	private static final String LOG_TAG = "HOSTAPPSERVICE";
    private ISetTextService appService = null;

    @Override
    public IBinder getBinder() {
        return serviceBinder;
    }

    @Override
    public void onCreate() {
      super.onCreate();
	  Log.d( LOG_TAG,"onCreate" );
    }

    @Override
    protected void onDestroy() {
	  super.onDestroy();
	  Log.d( LOG_TAG,"onDestroy" );
    }

    private final IHostappServiceIF.Stub serviceBinder = 
			new IHostappServiceIF.Stub() {
      public void setCallback( IBinder binder ) {
		Log.d( LOG_TAG,"setCallback" );		
		appService = ISetTextService.Stub.asInterface( binder );
      }

      public void setMyText( String myText ) {
		if( appService == null )
			Log.e( LOG_TAG, "setMyText callback: appService==null" );
		else {
		  try {
			appService.setMyText( myText );
		  } catch( DeadObjectException ex ) {
			Log.e( LOG_TAG,"setMyText callback: DeadObjectException" );
		  }
		}
	  }
    };


}