package aexp.sclientapp;

import android.app.Activity;
import android.os.Bundle;
import android.os.IBinder;
import android.os.DeadObjectException;
import android.util.Log;
import android.content.ComponentName;
import android.content.ServiceConnection;
import android.content.Intent;
import android.content.Context;
import aexp.hostapp.IHostappServiceIF;

public class SClientApp extends Activity {
	private static final String LOG_TAG = "SCLIENTAPP";
    private IHostappServiceIF service = null;
    private HostappServiceConnection conn = null;

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
		initService();
        setContentView(R.layout.main);
    }

    @Override
    protected void onDestroy() {
	  super.onDestroy();
	  releaseService();
    }

	private void initService() {
	  conn = new HostappServiceConnection();
	  Intent i = new Intent();
	  i.setClassName( "aexp.hostapp", "aexp.hostapp.HostappServiceImpl" );
	  bindService( i, null, conn, Context.BIND_AUTO_CREATE);
	}

	private void releaseService() {
	  unbindService( conn );	  
	  conn = null;
	}

    class HostappServiceConnection implements ServiceConnection {
        public void onServiceConnected(ComponentName className, 
			IBinder boundService ) {
          service = IHostappServiceIF.Stub.asInterface((IBinder)boundService);
		  Log.d( LOG_TAG,"onServiceConnected" );
		  try {
		    service.setMyText( "Message from SClientApp, timestamp: "+
				Long.toString( System.currentTimeMillis() ) );
		  } catch( DeadObjectException ex ) {
			Log.e( LOG_TAG,"DeadObjectException" );
		  }
          setResult(RESULT_OK);
          finish();
        }

        public void onServiceDisconnected(ComponentName className) {
          service = null;
		  Log.d( LOG_TAG,"onServiceDisconnected" );
        }
    };

}
